## sgt-puzzles 20230410.71cf891

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(puzzles
  LANGUAGES C)

include(cmake/setup.cmake)

add_library(common
  combi.c divvy.c drawing.c dsf.c findloop.c grid.c latin.c
  laydomino.c loopgen.c malloc.c matching.c midend.c misc.c penrose.c hat.c
  ps.c random.c sort.c tdq.c tree234.c version.c
  ${platform_common_sources})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

puzzle(blackbox
  DISPLAYNAME "Black Box"
  DESCRIPTION "Ball-finding puzzle"
  OBJECTIVE "Find the hidden balls in the box by bouncing laser beams \
off them.")

puzzle(bridges
  DISPLAYNAME "Bridges"
  DESCRIPTION "Bridge-placing puzzle"
  OBJECTIVE "Connect all the islands with a network of bridges.")

puzzle(cube
  DISPLAYNAME "Cube"
  DESCRIPTION "Rolling cube puzzle"
  OBJECTIVE "Pick up all the blue squares by rolling the cube over them.")

puzzle(dominosa
  DISPLAYNAME "Dominosa"
  DESCRIPTION "Domino tiling puzzle"
  OBJECTIVE "Tile the rectangle with a full set of dominoes.")
solver(dominosa)

puzzle(fifteen
  DISPLAYNAME "Fifteen"
  DESCRIPTION "Sliding block puzzle"
  OBJECTIVE "Slide the tiles around to arrange them into order.")
solver(fifteen)

puzzle(filling
  DISPLAYNAME "Filling"
  DESCRIPTION "Polyomino puzzle"
  OBJECTIVE "Mark every square with the area of its containing region.")
solver(filling)

puzzle(flip
  DISPLAYNAME "Flip"
  DESCRIPTION "Tile inversion puzzle"
  OBJECTIVE "Flip groups of squares to light them all up at once.")

puzzle(flood
  DISPLAYNAME "Flood"
  DESCRIPTION "Flood-filling puzzle"
  OBJECTIVE "Turn the grid the same colour in as few flood fills as possible.")

puzzle(galaxies
  DISPLAYNAME "Galaxies"
  DESCRIPTION "Symmetric polyomino puzzle"
  OBJECTIVE "Divide the grid into rotationally symmetric regions each \
centred on a dot.")
solver(galaxies)
cliprogram(galaxiespicture galaxies.c
  COMPILE_DEFINITIONS STANDALONE_PICTURE_GENERATOR)
guiprogram(galaxieseditor galaxies.c
  COMPILE_DEFINITIONS EDITOR)

puzzle(guess
  DISPLAYNAME "Guess"
  DESCRIPTION "Combination-guessing puzzle"
  OBJECTIVE "Guess the hidden combination of colours.")

puzzle(inertia
  DISPLAYNAME "Inertia"
  DESCRIPTION "Gem-collecting puzzle"
  OBJECTIVE "Collect all the gems without running into any of the mines.")

puzzle(keen
  DISPLAYNAME "Keen"
  DESCRIPTION "Arithmetic Latin square puzzle"
  OBJECTIVE "Complete the latin square in accordance with the \
arithmetic clues.")
solver(keen latin.c)

puzzle(lightup
  DISPLAYNAME "Light Up"
  DESCRIPTION "Light-bulb placing puzzle"
  OBJECTIVE "Place bulbs to light up all the squares.")
solver(lightup)

puzzle(loopy
  DISPLAYNAME "Loopy"
  DESCRIPTION "Loop-drawing puzzle"
  OBJECTIVE "Draw a single closed loop, given clues about number of \
adjacent edges.")
solver(loopy)

puzzle(magnets
  DISPLAYNAME "Magnets"
  DESCRIPTION "Magnet-placing puzzle"
  OBJECTIVE "Place magnets to satisfy the clues and avoid like poles \
touching.")
solver(magnets)

puzzle(map
  DISPLAYNAME "Map"
  DESCRIPTION "Map-colouring puzzle"
  OBJECTIVE "Colour the map so that adjacent regions are never the \
same colour.")
solver(map)

puzzle(mines
  DISPLAYNAME "Mines"
  DESCRIPTION "Mine-finding puzzle"
  OBJECTIVE "Find all the mines without treading on any of them.")
cliprogram(mineobfusc mines.c COMPILE_DEFINITIONS STANDALONE_OBFUSCATOR)

puzzle(mosaic
  DISPLAYNAME "Mosaic"
  DESCRIPTION "Grid-filling puzzle"
  OBJECTIVE "Fill in the grid given clues about number of \
nearby black squares.")

puzzle(net
  # The Windows Net shouldn't be called 'net.exe', since Windows
  # already has a reasonably important utility program by that name!
  WINDOWS_EXE_NAME netgame

  DISPLAYNAME "Net"
  DESCRIPTION "Network jigsaw puzzle"
  OBJECTIVE "Rotate each tile to reassemble the network.")

puzzle(netslide
  DISPLAYNAME "Netslide"
  DESCRIPTION "Toroidal sliding network puzzle"
  OBJECTIVE "Slide a row at a time to reassemble the network.")

puzzle(nullgame)

puzzle(palisade
  DISPLAYNAME "Palisade"
  DESCRIPTION "Grid-division puzzle"
  OBJECTIVE "Divide the grid into equal-sized areas in accordance with\
 the clues.")

puzzle(pattern
  DISPLAYNAME "Pattern"
  DESCRIPTION "Pattern puzzle"
  OBJECTIVE "Fill in the pattern in the grid, given only the lengths \
of runs of black squares.")
solver(pattern)
cliprogram(patternpicture pattern.c
  COMPILE_DEFINITIONS STANDALONE_PICTURE_GENERATOR)

puzzle(pearl
  DISPLAYNAME "Pearl"
  DESCRIPTION "Loop-drawing puzzle"
  OBJECTIVE "Draw a single closed loop, given clues about corner and \
straight squares.")
solver(pearl)
cliprogram(pearlbench pearl.c COMPILE_DEFINITIONS STANDALONE_SOLVER)

puzzle(pegs
  DISPLAYNAME "Pegs"
  DESCRIPTION "Peg solitaire puzzle"
  OBJECTIVE "Jump pegs over each other to remove all but one.")

puzzle(range
  DISPLAYNAME "Range"
  DESCRIPTION "Visible-distance puzzle"
  OBJECTIVE "Place black squares to limit the visible distance from \
each numbered cell.")

puzzle(rect
  DISPLAYNAME "Rectangles"
  DESCRIPTION "Rectangles puzzle"
  OBJECTIVE "Divide the grid into rectangles with areas equal to the \
numbers.")

puzzle(samegame
  DISPLAYNAME "Same Game"
  DESCRIPTION "Block-clearing puzzle"
  OBJECTIVE "Clear the grid by removing touching groups of the same \
colour squares.")

puzzle(signpost
  DISPLAYNAME "Signpost"
  DESCRIPTION "Square-connecting puzzle"
  OBJECTIVE "Connect the squares into a path following the arrows.")
solver(signpost)

puzzle(singles
  DISPLAYNAME "Singles"
  DESCRIPTION "Number-removing puzzle"
  OBJECTIVE "Black out the right set of duplicate numbers.")
solver(singles)

puzzle(sixteen
  DISPLAYNAME "Sixteen"
  DESCRIPTION "Toroidal sliding block puzzle"
  OBJECTIVE "Slide a row at a time to arrange the tiles into order.")

puzzle(slant
  DISPLAYNAME "Slant"
  DESCRIPTION "Maze-drawing puzzle"
  OBJECTIVE "Draw a maze of slanting lines that matches the clues.")
solver(slant)

puzzle(solo
  DISPLAYNAME "Solo"
  DESCRIPTION "Number placement puzzle"
  OBJECTIVE "Fill in the grid so that each row, column and square \
block contains one of every digit.")
solver(solo)

puzzle(tents
  DISPLAYNAME "Tents"
  DESCRIPTION "Tent-placing puzzle"
  OBJECTIVE "Place a tent next to each tree.")
solver(tents)

puzzle(towers
  DISPLAYNAME "Towers"
  DESCRIPTION "Tower-placing Latin square puzzle"
  OBJECTIVE "Complete the latin square of towers in accordance with \
the clues.")
solver(towers latin.c)

puzzle(tracks
  DISPLAYNAME "Tracks"
  DESCRIPTION "Path-finding railway track puzzle"
  OBJECTIVE "Fill in the railway track according to the clues.")
solver(tracks)

puzzle(twiddle
  DISPLAYNAME "Twiddle"
  DESCRIPTION "Rotational sliding block puzzle"
  OBJECTIVE "Rotate the tiles around themselves to arrange them into order.")

puzzle(undead
  DISPLAYNAME "Undead"
  DESCRIPTION "Monster-placing puzzle"
  OBJECTIVE "Place ghosts, vampires and zombies so that the right \
numbers of them can be seen in mirrors.")

puzzle(unequal
  DISPLAYNAME "Unequal"
  DESCRIPTION "Latin square puzzle"
  OBJECTIVE "Complete the latin square in accordance with the > signs.")
solver(unequal latin.c)

puzzle(unruly
  DISPLAYNAME "Unruly"
  DESCRIPTION "Black and white grid puzzle"
  OBJECTIVE "Fill in the black and white grid to avoid runs of three.")
solver(unruly)

puzzle(untangle
  DISPLAYNAME "Untangle"
  DESCRIPTION "Planar graph layout puzzle"
  OBJECTIVE "Reposition the points so that the lines do not cross.")

add_subdirectory(unfinished)
add_subdirectory(auxiliary)

if(build_cli_programs)
  write_generated_games_header()
  include(CheckFunctionExists)
  check_function_exists(HF_ITER HAVE_HF_ITER)
  set(WITH_LIBFUZZER OFF
    CACHE BOOL "Build fuzzpuzz using Clang's libFuzzer")
  cliprogram(fuzzpuzz fuzzpuzz.c list.c ${puzzle_sources}
    COMPILE_DEFINITIONS COMBINED $<$<BOOL:${WITH_LIBFUZZER}>:OMIT_MAIN>
    $<$<BOOL:${HAVE_HF_ITER}>:HAVE_HF_ITER>)
  target_include_directories(fuzzpuzz PRIVATE ${generated_include_dir})
  if(WITH_LIBFUZZER)
    target_compile_options(fuzzpuzz PRIVATE -fsanitize=fuzzer)
    set_target_properties(fuzzpuzz PROPERTIES LINK_FLAGS -fsanitize=fuzzer)
  endif()
endif()

build_extras()

=== auxiliary/CMakeLists.txt ===
cliprogram(combi-test combi-test.c)
cliprogram(divvy-test divvy-test.c)
cliprogram(hatgen hatgen.c COMPILE_DEFINITIONS TEST_HAT)
cliprogram(hat-test hat-test.c)
cliprogram(latin-test latin-test.c)
cliprogram(matching matching.c)
cliprogram(obfusc obfusc.c)
cliprogram(penrose-test penrose-test.c)
cliprogram(sort-test sort-test.c)
cliprogram(tree234-test tree234-test.c)

=== unfinished/CMakeLists.txt ===
puzzle(group
  DISPLAYNAME "Group"
  DESCRIPTION "Group theory puzzle"
  OBJECTIVE "Complete the unfinished Cayley table of a group.")
solver(group ${CMAKE_SOURCE_DIR}/latin.c)

puzzle(separate
  DISPLAYNAME "Separate"
  DESCRIPTION "Rectangle-dividing puzzle"
  OBJECTIVE "Partition the grid into regions containing one of each letter.")

puzzle(slide
  DISPLAYNAME "Slide"
  DESCRIPTION "Sliding block puzzle"
  OBJECTIVE "Slide the blocks to let the key block out.")
solver(slide)

puzzle(sokoban
  DISPLAYNAME "Sokoban"
  DESCRIPTION "Barrel-pushing puzzle"
  OBJECTIVE "Push all the barrels into the target squares.")

# These unfinished programs don't even have the structure of a puzzle
# game yet; they're just command-line programs containing test
# implementations of some of the needed functionality.

cliprogram(numgame numgame.c)

cliprogram(path path.c COMPILE_DEFINITIONS TEST_GEN)

export_variables_to_parent_scope()

=== debian/changelog ===
sgt-puzzles (20230410.71cf891-2) unstable; urgency=medium

  * d/rules: Add update-po target to update PO files in patches
  * d/patches: Update PO files
  * Update German translation, thanks to Helge Kreutzmann (Closes: #1034517)

 -- Ben Hutchings <benh@debian.org>  Sat, 03 Jun 2023 23:25:49 +0200

sgt-puzzles (20230410.71cf891-1) experimental; urgency=medium

  * New upstream version:
    - Note in the documentation that Pattern clues are in order
      (Closes: #642207)
    - Solo: cope with pencil marks when tilesize == 1 (Closes: #905852)
    - Multiple fixes for security issues in game loading (Closes: #1034190)
  * d/rules: Fix various bugs in update-upstream rule

 -- Ben Hutchings <benh@debian.org>  Tue, 11 Apr 2023 01:30:57 +0200

=== debian/control ===
Source: sgt-puzzles
Maintainer: Ben Hutchings <benh@debian.org>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13), halibut, libgtk-3-dev, libgtk-3-dev:native, liblocale-po-perl:native, po4a, cmake, imagemagick
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://www.chiark.greenend.org.uk/~sgtatham/puzzles/
Vcs-Git: https://salsa.debian.org/benh/sgt-puzzles.git
Vcs-Browser: https://salsa.debian.org/benh/sgt-puzzles

Package: sgt-puzzles
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: xdg-utils, www-browser
Description: Simon Tatham's Portable Puzzle Collection - 1-player puzzle games
 Simon Tatham's Portable Puzzle Collection contains a number of popular
 puzzle games for one player.  It currently consists of these games:
 .
  * Black Box, ball-finding puzzle
  * Bridges, bridge-placing puzzle
  * Cube, rolling cube puzzle
  * Dominosa, domino tiling puzzle
  * Fifteen, sliding block puzzle
  * Filling, polyomino puzzle
  * Flip, tile inversion puzzle
  * Flood, flood-filling puzzle
  * Galaxies, symmetric polyomino puzzle
  * Guess, combination-guessing puzzle
  * Inertia, gem-collecting puzzle
  * Keen, arithmetic Latin square puzzle
  * Light Up, light-bulb placing puzzle
  * Loopy, loop-drawing puzzle
  * Magnets, magnet-placing puzzle
  * Map, map-colouring puzzle
  * Mines, mine-finding puzzle
  * Mosaic, grid-filling puzzle
  * Net, network jigsaw puzzle
  * Netslide, toroidal sliding network puzzle
  * Palisade, grid-division puzzle
  * Pattern, pattern puzzle
  * Pearl, loop-drawing puzzle
  * Pegs, peg solitaire puzzle
  * Range, visible-distance puzzle
  * Rectangles, rectangles puzzle
  * Same Game, block-clearing puzzle
  * Signpost, square-connecting puzzle
  * Singles, number-removing puzzle
  * Sixteen, toroidal sliding block puzzle
  * Slant, maze-drawing puzzle
  * Solo, number placement puzzle
  * Tents, tent-placing puzzle
  * Towers, tower-placing Latin square puzzle
  * Tracks, path-finding railway track puzzle
  * Twiddle, rotational sliding block puzzle
  * Undead, monster-placing puzzle
  * Unequal, Latin square puzzle
  * Unruly, black and white grid puzzle
  * Untangle, planar graph layout puzzle

=== debian/rules ===
#!/usr/bin/make -f

# We require some bash features
override SHELL := /bin/bash

include /usr/share/dpkg/pkg-info.mk

DEB_CFLAGS_MAINT_APPEND := -Wno-error=deprecated-declarations
DEB_CPPFLAGS_MAINT_APPEND := -DDEBIAN_VERSION='\"$(DEB_VERSION)\"'
DPKG_EXPORT_BUILDFLAGS := 1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildtools.mk

LANGUAGES := en $(patsubst po/%.po,%,$(wildcard po/*.po))

# Files that have version strings substituted in the tarball but never in git
VERSION_SUB_FILES := devel.but osx/Info.plist puzzles.but version.h

%:
	dh $@ --without autoreconf

CMAKE_OPTS := -DNAME_PREFIX=sgt- -DCMAKE_INSTALL_BINDIR=/usr/games

override_dh_auto_configure:
# In a cross-build, we need to first do a native build to generate the
# icon files.  In a fully native build this is done automatically.
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	mkdir -p obj-$(DEB_BUILD_GNU_TYPE)
	cd obj-$(DEB_BUILD_GNU_TYPE) && cmake $(CMAKE_OPTS) ..
	$(MAKE) -C obj-$(DEB_BUILD_GNU_TYPE) VERBOSE=$(if $(filter terse,$(DEB_BUILD_OPTIONS)),0,1)
	cp obj-$(DEB_BUILD_GNU_TYPE)/icons/*-icon.c icons/
endif
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_build:
	dh_auto_build
	cp obj-$(DEB_HOST_GNU_TYPE)/gamedesc.txt .
	$(MAKE) -f Makefile.doc BINPREFIX=sgt-

# Disable running tests; they are quite slow and don't seem likely to catch
# regressions.
override_dh_auto_test:

override_dh_installdocs:
	for lang in $(LANGUAGES); do \
		dh_install html-$$lang/*.html usr/share/sgt-puzzles/help/$$lang \
		|| exit; \
	done
	dh_installdocs

override_dh_installman:
	for lang in $(LANGUAGES); do \
		dh_installman --language=$${lang/en/C} man-$$lang/* || exit; \
	done

override_dh_auto_clean:
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
	rm -rf obj-$(DEB_BUILD_GNU_TYPE)
	rm -f icons/*-icon.c
endif
	dh_auto_clean
	rm -f gamedesc.txt
	$(MAKE) -f Makefile.doc clean

FORCE:
.PHONY: FORCE

../puzzles.tar.gz: FORCE
	curl -L -R -o $@ $(if $(wildcard $@),-z $@) https://www.chiark.greenend.org.uk/~sgtatham/puzzles/puzzles.tar.gz

../puzzles.tar.version: ../puzzles.tar.gz
	version="$$(tar -xOzf $< --wildcards '*/version.h' | \
		    sed -n 's/^\#define VER "Version \([^ ]*\)"$$/\1/p')" && \
	test "$${version#*.}" != "$$version" &&				\
	echo "$$version" > $@

# Updating to a new upstream includes a rebase which will often
# require manual fixup.  Split the commands into two targets so it's
# possible to continue after that point.
update-upstream:
	debian/rules update-upstream-1
	debian/rules update-upstream-2
update-upstream-1: ../puzzles.tar.gz ../puzzles.tar.version
	test ! -d .pc || quilt pop -a
	version="$$(cat ../puzzles.tar.version)" &&			\
	upstream_commit="$${version#*.}" &&				\
	git tag -f -m "Upstream version $$version" "upstream/$$version"	\
		"$$upstream_commit" &&					\
	git deborig --force --version "$$version" &&			\
	git merge "upstream/$$version"
update-upstream-2:
	QUILT_PATCHES=debian/patches quilt push 0001-Apply-version-string-substitutions-from-the-tarball.patch
	tar -xzf ../puzzles.tar.gz --strip-components=1 --wildcards	\
		$(addprefix '*/',$(VERSION_SUB_FILES))
	quilt refresh
	quilt push -a
.PHONY: update-upstream

update-po:
	set +e; quilt unapplied >/dev/null && echo 'Patch series not fully applied'; test $$? -eq 1
	dh_auto_configure -- $(CMAKE_OPTS)
	cp obj-$(DEB_HOST_GNU_TYPE)/gamedesc.txt .
	make -f Makefile.doc update-po
	quilt pop 0003-Add-German-translation-of-documentation.patch
	quilt refresh
	quilt pop 206_translate-docs.diff
	quilt refresh
	quilt push -a
.PHONY: update-po

## sgt-puzzles 20250730.a7c7826

=== debian/changelog ===
sgt-puzzles (20250730.a7c7826-1) unstable; urgency=medium

  * New upstream version:
    - Universal preference option for one-key shortcuts. (Closes: #363441)
    - Mosaic: Fix buffer overflow in game_text_format() (Closes: #1079717)
    - Loopy / grid.c: support the new Spectre monotiling. (Closes: #1116973)
  * d/patches: Update for new upstream version
    - Update "Apply version string substitutions from the tarball"
    - Refresh "Add HTML-based online help"
    - Drop "Install both 48x48 and 96x96 icons", redundant with upstream
      change to install all icon sizes
  * Update German translation, thanks to Helge Kreutzmann
  * slant: Shade empty rather than filled squares, and make this optional
    (Closes: #550311)

 -- Ben Hutchings <benh@debian.org>  Tue, 03 Mar 2026 16:19:06 +0100
